/*
* libSwitchErrors.h
*
*  Created on: Sep 15, 2011
*      Author: Praveen
*/
#ifndef LIBSWITCHERRORS_H_
#define LIBSWITCHERRORS_H_

#include "vtexCommonErrors.h"

enum {
#ifndef _SwitchErrors_H
    //! IVI switch errors.
    IVISWTCH_E_TRIGGER_NOT_SOFTWARE = 0x80041001, /* IVI wants this to be the same code for all driver types, so it's out of order */
    IVISWTCH_E_INVALID_SWITCH_PATH = 0x80042001,
    IVISWTCH_E_INVALID_SCAN_LIST = 0x80042002,
    IVISWTCH_E_RSRC_IN_USE = 0x80042003,
    IVISWTCH_E_EMPTY_SCAN_LIST = 0x80042004,
    IVISWTCH_E_EMPTY_SWITCH_PATH = 0x80042005,
    IVISWTCH_E_SCAN_IN_PROGRESS = 0x80042006,
    IVISWTCH_E_NO_SCAN_IN_PROGRESS = 0x80042007,
    IVISWTCH_E_NO_SUCH_PATH = 0x80042008,
    IVISWTCH_E_IS_CONFIGURATION_CHANNEL = 0x80042009,
    IVISWTCH_E_NOT_A_CONFIGURATION_CHANNEL = 0x8004200a,
    IVISWTCH_E_ATTEMPT_TO_CONNECT_SOURCES = 0x8004200b,
    IVISWTCH_E_EXPLICIT_CONNECTION_EXISTS = 0x8004200c,
    IVISWTCH_E_LEG_MISSING_FIRST_CHANNEL = 0x8004200d,
    IVISWTCH_E_LEG_MISSING_SECOND_CHANNEL = 0x8004200e,
    IVISWTCH_E_CHANNEL_DUPLICATED_IN_LEG = 0x8004200f,
    IVISWTCH_E_CHANNEL_DUPLICATED_IN_PATH = 0x80042010,
    IVISWTCH_E_PATH_NOT_FOUND = 0x80042011,
    IVISWTCH_E_DISCONTINUOUS_PATH = 0x80042012,
    IVISWTCH_E_CANNOT_CONNECT_DIRECTLY = 0x80042013,
    IVISWTCH_E_CHANNELS_ALREADY_CONNECTED = 0x80042014,
    IVISWTCH_E_CANNOT_CONNECT_TO_ITSELF = 0x80042015,
    IVISWTCH_E_MAX_TIME_EXCEEDED = 0x80042016,

    //! IVI switch warnings.
    IVISWTCH_W_PATH_REMAINS = 0x42001,
    IVISWTCH_W_IMPLICIT_CONNECTION_EXISTS = 0x42002,

    //! Device errors.
    FWSWITCH_E_BASE = 0x80018000,

    FWSWITCH_E_PARM_LEN_MISMATCH = 0x80018001,
    FWSWITCH_E_FPGA_IO = 0x80018002,
    FWSWITCH_E_INVALID_SCAN_DELAY = 0x80018003,
    FWSWITCH_E_INVALID_SCAN_MODE = 0x80018004,
    FWSWITCH_E_INVALID_TRIG_SOURCE = 0x80018005,
    FWSWITCH_E_INVALID_RELAY_IDX = 0x80018006,
    FWSWITCH_E_INVALID_ODOMETER_SRC = 0x80018007,
    FWSWITCH_E_INVALID_ARRAY_LEN = 0x80018008,
    FWSWITCH_E_INVALID_COIL_BITMAP_OFFSET = 0x80018009,
    FWSWITCH_E_INVALID_ODOMETER_LEN_IN_FLASH = 0x8001800a,
    FWSWITCH_E_INVALID_SCANLIST_SIZE = 0x8001800b,
    FWSWITCH_E_SCANLIST_EXCEEDS_BUF = 0x8001800c,
    FWSWITCH_E_INVALID_TIMEOUT = 0x8001800d,
    FWSWITCH_E_FLASH_FILE_OPERATION_FAILED = 0x8001800e,
    FWSWITCH_E_FPGA_INTERNAL_ERROR = 0x8001800f,
    FWSWITCH_E_FUNCTIONALITY_NOT_AVAILABLE = 0x80018010,
    FWSWITCH_E_MEM_ALLOC_FAILED = 0x80018011,
    FWSWITCH_E_FAILED_TO_OPEN_SCANNER_DEVICE = 0x80018012,
    FWSWITCH_E_NULL_POINTER_ARGUMENT = 0x80018013,
    FWSWITCH_E_NULL_PRIVATE_SLOT_DATA = 0x80018014,
    FWSWITCH_E_INVALID_MODULE_IN_SLOT = 0x80018015,
    FWSWITCH_E_STATE_MISMATCH_DRIVEN_STATE = 0x80018016,
    FWSWITCH_E_STATE_MISMATCH_READBACK_STATE = 0x80018017,
    FWSWITCH_E_INVALID_BOARD_INDEX = 0x80018018,
    FWSWITCH_E_INVALID_FRAM_OFFSET = 0x80018019,
    FWSWITCH_E_INVALID_SAVED_STATE_INDEX = 0x8001801a,
    FWSWITCH_E_SAVED_STATE_INDEX_UNDEFINED = 0x8001801b,
    FWSWITCH_E_RDB_NOT_INSTALLED = 0x8001801c,
    FWSWITCH_E_RELAY_FAILURE = 0x8001801d,
    FWSWITCH_E_READ_WHILE_RELAY_SETTLING_IN_PHASE2 = 0x8001801e,
    FWSWITCH_E_FPGA_ERROR_UNKNOWN = 0x8001801f,
    FWSWITCH_E_SCANBUFFER_WRITE_ERROR = 0x80018020,
    FWSWITCH_E_SCANNER_FAILURE = 0x80018021,
    FWSWITCH_E_INVALID_TRIGGER = 0x80018022,
    FWSWITCH_E_OTHER_CMDS_WHILE_RELAY_WRITE_IN_PROGRESS = 0x80018023,
    FWSWITCH_E_WRONG_CMDS_FOR_PIO_OPS = 0x80018024,
    FWSWITCH_E_FRONT_PANEL_OPEN_SIGNAL_ACTIVE = 0x80018025,

    FWPLATFORM_E_TIMEOUT = 0x80008004,

    // Additional errors defined by the EX1200 Switch Driver
    // NOTE: these are now defined within the range allowed by IVI
    VTEXSWITCH_E_CHANNELS_ARE_FROM_DIFFERENT_PLUGIN_MODULES = 0x80044401,
    VTEXSWITCH_E_SETPATH_DISCONTINUOUS_PATH = 0x80044402,
    VTEXSWITCH_E_SLOTNUMBER_NOT_FOUND_IN_TABLE = 0x80044403,
    VTEXSWITCH_E_INTERNAL_ERROR_WHILE_PROCESSING_SCANLIST = 0x80044404,
    VTEXSWITCH_E_CHANNEL_NOT_A_SOURCE_CHANNEL = 0x80044405,
    VTEXSWITCH_E_CHANNEL_ONE_UNKNOWN = 0x80044406,
    VTEXSWITCH_E_CHANNEL_TWO_UNKNOWN = 0x80044407,
    VTEXSWITCH_E_RELAY_CURRENTLY_IN_USE = 0x80044408,
    VTEXSWITCH_E_CANNOT_DISCONNECT_ITSELF = 0x80044409,
    VTEXSWITCH_E_INVALID_COILVALUE = 0x8004440a,
    // removed error code VTEXSWITCH_E_EXCLUDE_LIST_ALREADY_ADDED
    VTEXSWITCH_E_UNKNOWN_EXCLUDE_LIST = 0x8004440c,
    VTEXSWITCH_E_DUPLICATE_EXCLUDE_LIST_NAME = 0x8004440d,
    VTEXSWITCH_E_EXCLUDE_LIST_VIOLATED = 0x8004440e,
    // removed error code VTEXSWITCH_E_INVALID_EXCLUDE_LIST
    VTEXSWITCH_E_INTERNAL_DRIVER_DATASTRUCTURE_CORRUPTION = 0x80044410,
    VTEXSWITCH_E_RESOURCE_CONFLICT_EXISTS = 0x80044411,
    VTEXSWITCH_E_INVALID_SWITCH_PATH = 0x80044412,
    VTEXSWITCH_E_INVALID_BOOLEAN_VALUE = 0x80044413,
    VTEXSWITCH_E_COMMUNICATION_ERROR_WITH_INSTRUMENT = 0x80044414,
    VTEXSWITCH_E_ERROR_PARSING_SWITCH_PATH_STRING = 0x80044415,
    VTEXSWITCH_E_CHANNEL_WIRE_MODES_MISMATCH = 0x80044416,
    VTEXSWITCH_E_UNKNOWN_RELAY = 0x80044417,
    VTEXSWITCH_E_SOURCE_CHANNELS_LIST_VIOLATED = 0x80044418,
    VTEXSWITCH_E_INVALID_RELAY_TO_TOGGLE = 0x80044419,
    VTEXSWITCH_E_FPGA_READBACK_MISMATCH = 0x8004441a,
    VTEXSWITCH_E_UNKNOWN_BIT_PATTERN = 0x8004441b,
    VTEXSWITCH_E_INVALID_RELAY_TO_QUERY = 0x8004441c,
    VTEXSWITCH_E_QUERYING_ODOMETER_OF_MULTICOIL_RELAY = 0x8004441d,
    VTEXSWITCH_E_RELAY_IN_SCANLIST_CANT_PERFORM_MBB = 0x8004441e,

    VTEX_E_WRONG_MODE = 0x80044420,
    VTEX_E_INTERNAL_NULL_POINTER = 0x80044421,
    VTEX_E_DCF_MALFORMED = 0x80044422,
    VTEX_E_DCF_AVAILABLE = 0x80044423,
    VTEX_E_SIMULATING_WITH_NO_SLOTS_SPECIFIED = 0x80044424,
    VTEX_E_SIMULATION_NO_ENVIRONMENT_VAR = 0x80044425,
    VTEX_E_UNKNOWN_MODULE_TYPE = 0x80044426,

#endif //_SwitchErrors_H for the 1200 errors

    // SMX-specific errors
    VTEX_E_SWITCH_SELFTEST_FAILED = 0x80044451,
    VTEX_E_SWITCH_SELFTEST_CANNOT_COMPLETE,
};

#endif /* ! LIBSWITCHERRORS_H_ */
