/******************************************************************************
 *
 *  .----------------------.    
 *  |==     ==  ======  == |    $Author: kmarcey $
 *  | ==   ==   ======  == |    $Revision: 37103 $ 
 *  |  == ==      ==    == |    $Date: 2017-05-12 11:12:06 -0700 (Fri, 12 May 2017) $ 
 *  |   ===       ==    == |    $HeadURL: http://orion/svn/spiderman/branches/v1_13_14_and_higher/host/driver/lib/common/vtexArray.h $
 *  |    =        ==    == |    
 *  `----------------------'
 *
 * Copyright 2006 VXI Technology Inc. as an unpublished work. 
 * All rights reserved. The information contained herein is confidential
 * property of VXI Technology, Inc. Use, copy, transfer or disclosure
 * of such information is prohibited except by express written agreement 
 * with VXI Technology, Inc.
 *
 * PURPOSE: 
 *   Template class for various IVI properties
 *
 * First Written By: David Sigler On Jan-2007
 ******************************************************************************/
 
#ifndef _ARRAY_TEMPLATE_
#define _ARRAY_TEMPLATE_

#include "vtexExport.h"

template <typename Container, typename ValueType, typename IndexType>
class VTEX_EXPORT arrayizer
{
public:
    arrayizer()
    {
        m_container = NULL;
        m_get = NULL;
    }
    
    void SetAttributes(Container *container,
      ValueType (Container::*get)(IndexType value))
    {
        m_container = container;
        m_get = get;
    }
    
    ValueType operator [](IndexType index)
    {
        return (m_container->*m_get)(index);
    }

private:
    Container *m_container;
    ValueType (Container::*m_get)(IndexType value);
};

#endif //_ARRAY_TEMPLATE_

